#!  /usr/bin/python
# coding: utf8
# author: zmej74
import sys, os
import xbmcaddon, xbmcgui, xbmc
#import json as simplejson
#import datetime,  commands
#ll = open("d:/tmp/start_emu.log", "w")
#print >>ll, "Start constant"



# Plugin constants
__addonname__ = "Softcam Manager"
__addonid__   = "plugin.program.softcam-manager"
__addon__     = xbmcaddon.Addon(id=__addonid__)
__language__  = __addon__.getLocalizedString
__cwd__       = xbmc.translatePath( __addon__.getAddonInfo('path') )
__profile__   = xbmc.translatePath( __addon__.getAddonInfo('profile') )
__icondir__   = os.path.join( __cwd__,'resources','images' )

# Shared resources
BASE_RESOURCE_PATH = os.path.join( __cwd__, 'resources', 'lib' )
sys.path.append(BASE_RESOURCE_PATH)
#AUTO_START = __addon__.getSetting('AutomaticStart')

__tmpfile = "/tmp/emupack.log" if os.name == "posix" else "c:/temp/emupack.log"
def RunDialog( ):
    skin_files = ["softcam_main_modern.xml", "softcam_main_classic.xml"]
    skin = skin_files[ int(__addon__.getSetting('skin_id') ) ]
    lfile = open(__tmpfile, "w")
    print >> lfile, "Opening library..."
    import emu, emugui
    print >> lfile, "Begin dialog..."
    #lfile.close()
    em = emu.emu_manager()
    em.log = lfile
    em.addonname = __addonname__
    em.addonid = __addonid__
    em.addon = __addon__
    em.cwd = __cwd__
    em.language = __language__
    print >> lfile, "Created emu manager..."
    em.loadEmus()
    print >> lfile, "Emu descriptions loaded ..."
    eg = emugui.EmuWindow(skin, __cwd__)
    eg.addon = __addon__
    eg.addon_path = __cwd__
    eg.emu_manager = em
    print >> lfile, "Create controls ..."
    #eg.fillControls()
    print >> lfile, "controls created..."
    eg.show()
    period = 100
    allperiod = 5000
    curperiod = 0
    eg.ecmRefresh( em.infoEcm() )
    while not eg.flagExit:
        xbmc.sleep(period)
        curperiod += period
        if curperiod >= allperiod:
            curperiod = 0
            eg.ecmRefresh( em.infoEcm() )
    #xbmc.sleep(10000)
    em.logout("Deleting window... ")
    del eg
    em.logout(type(em))
    #em.logout( em.strlanguage( 30001, "Main menu"))
    #em.logout( "end!")
    lfile.close()
if __name__ == '__main__' :
    #print 'EMU TEST'
    RunDialog( )



