# coding: utf8
# author: zmej74
#import sys, os
import os
#import xbmcaddon, xbmcplugin, xbmcgui, xbmc
import xbmcgui

# Коды клавиатурных комманд.
ACTION_PREVIOUS_MENU = 10 # Esc
ACTION_NAV_BACK = 92 # Backspace
ACTION_RED = 410 # red button

class emuinfo(xbmcgui.WindowXMLDialog):
    """
    класс для отображения информации об эмуляторе
    """
    def __init__(self, fxml, scdir, dir1="", dir2=""):
        self.emu = None
        self.images = {}
        self.controls = {"emu_name":300, "emu_id":302, "emu_bin":304, "emu_config":306, "emu_multi":308, "emu_load":310}
        self.btn_controls = {}
        self.addon = None
        self.addon_path = ""

    def onInit(self):
        #self.dialog.ok(u'Editor => ', "before load" )
        self.getControl(self.controls["emu_name"]).addLabel(self.emu.emu_name)
        #
        self.getControl(self.controls["emu_id"]).addLabel(self.emu.emu_id)
        #
        self.getControl(self.controls["emu_bin"]).addLabel(os.path.join(self.emu.bin_path,self.emu.emu_bin))
        #
        #mess = self.emu.config_path if os.path.isdir(self.emu.config_path) else self.strlanguage(30056,u"Path does not exist")
        mess = self.emu.config_path
        self.getControl(self.controls["emu_config"]).addLabel(mess)
        #
        status = self.strlanguage(30053,u"Yes") if self.emu.multiconf else self.strlanguage(30054,u"No")
        self.getControl(self.controls["emu_multi"]).addLabel(status)
         #
        status = self.strlanguage(30053,u"Yes") if (os.name == "posix" and self.emu.emu_running()) else self.strlanguage(30054,u"No")
        self.getControl(self.controls["emu_load"]).addLabel(status)
        #

    def onAction(self, action):
        # Обрабатываем нажатия кнопок для выхода из плагина.
        if action == ACTION_NAV_BACK or action == ACTION_PREVIOUS_MENU or action == ACTION_RED:
            self.close()

    def strlanguage(self, id_str, altstr=""):
        try:
            onestr = self.addon.getLocalizedString( id_str )
        except:
            onestr = ""
        if onestr:
            return onestr
        else:
            return altstr
