# coding: utf8
# author: zmej74
import commands, datetime
import addon
import emu
class printsysinfo():
    """ 
    выводит в файл инфо о системе и эмуляторах
    """
    def __init__(self):
        self.fileout_name = ''
        self.fileout = None
        self.infos = {}
        self.flagopen = False
        
    def openfile(self):
        try:
            self.fileout = open(self.fileout_name, 'w')
            self.flagopen = True
        except:
            pass
        return self.flagopen
        
    def closefile(self):
        self.fileout.close()
    
    def toFile(self, str, flagadd=False):
        if flagadd:
            print >> self.fileout, str, 
        else:
            print >> self.fileout, str
    
    def printall(self):
        """
        инфо по инсталированным эму
        активный эму
        список процессов
        папка cams
        папка post-maruapp
        папка pre-maruapp
        папка /var/keys
        """
        if not self.openfile():
            return False
        curDate = datetime.datetime.now()
        self.toFile(curDate.strftime("%Y-%m-%d %H:%M:%S"))
        self.toFile('---------- %s -------------' % addon.ADDON_NAME)
        self.toFile('Id of addon: %s' % addon.ADDON_ID)
        self.toFile('Path to addon: %s' % addon.ADDON_PATH)
        self.toFile('########## Info about installed EMUs ###########')
        self.infoemu()
        for one in self.infos['emus']:
            self.toFile(one)
        self.toFile('########## The list of processes ############')
        self.infops()
        for one in self.infos['ps']:
            self.toFile(one)
        self.toFile('########## The list of folder /config/cams ############')
        self.infocams()
        for one in self.infos['cams']:
            self.toFile(one)
        self.toFile('########## The list of folder /config/pre-maruapp ############')
        self.infopre()
        for one in self.infos['pre']:
            self.toFile(one)
        self.toFile('########## The list of folder /config/post-maruapp ############')
        self.infopost()
        for one in self.infos['post']:
            self.toFile(one)
        self.toFile('########## The list of folder /var/keys ############')
        self.infovar()
        for one in self.infos['var']:
            self.toFile(one)
        self.closefile()
    
    def infoemu(self):
        em = emu.emu_manager()
        #em.log = lfile
        em.addonname = addon.ADDON_NAME
        em.addonid = addon.ADDON_ID
        em.addon = addon.ADDON
        em.cwd = addon.ADDON_PATH
        em.language = addon.ADDON_LANGUAGE
        em.loadEmus()
        info_emu = []
        active_emu_info = ''
        for one in em.emus:
            info_emu.append('**** EMU: %s *****' % one.emu_name)
            info_emu.append('\tId: %s' % one.emu_id)
            info_emu.append('\tVersion: %s' % one.emu_version)
            info_emu.append('\tBinary file: %s' % one.emu_bin)
            info_emu.append('\tBinary path: %s' % one.bin_path)
            info_emu.append('\tConfig path: %s' % one.config_path)
            info_emu.append('\tStart binary path: %s' % one.start_bin_path)
            info_emu.append('\tStart config path: %s' % one.start_config_path)
            info_emu.append('\tCommand to run: %s' % one.command)
            info_emu.append('\tScript to run: %s' % one.script_start)
            if one.emu_running():
                active_emu_info = one.emu_name
        if active_emu_info:
            info_emu.append('\n****Active EMU: %s' % active_emu_info)
        else:
            info_emu.append('\n****Active EMU: None')
        self.infos["emus"] = info_emu
        del em
        
    def infops(self):
        info_ps = []
        info_ps.append(commands.getoutput('ps -ela'))
        self.infos["ps"] = info_ps
    
    def infopost(self):
        info_post = []
        info_post.append(commands.getoutput(' ls /config/post-maruapp -a -1 -F -R -l'))
        self.infos["post"] = info_post
    
    def infopre(self):
        info_pre = []
        info_pre.append(commands.getoutput(' ls /config/pre-maruapp -a -1 -F -R -l'))
        self.infos["pre"] = info_pre
        
    def infocams(self):
        info_cams = []
        info_cams.append(commands.getoutput(' ls /config/cams -a -1 -F -R -l'))
        self.infos["cams"] = info_cams
    
    def infovar(self):
        info_var = []
        info_var.append(commands.getoutput(' ls /var/keys -al'))
        info_var.append(commands.getoutput(' ls /var/keys -a -1 -F -R'))
        self.infos["var"] = info_var
            
            
            
            
            
            
            
            
            
            
            
            
            
            
