# coding: utf8
# author: zmej74
import xbmcgui, xbmcaddon
import keysdownloader

dialog = xbmcgui.Dialog()
addonid   = "plugin.program.softcam-manager"
addon     = xbmcaddon.Addon(id=addonid)
#
pars = [
        {"name":"softcamkey", "enable":"sck_download", "realname":"sck_filename", "url":"sck_url",
            "path":["sck_folder1","sck_folder2","sck_folder3","sck_folder4"], 
            "sourcetype":'sck_source', "file":'sck_file'},
        {"name":"constantcw", "enable":"ccw_download", "realname":"ccw_filename", "url":"ccw_url",
            "path":["ccw_folder1","ccw_folder2","ccw_folder3","ccw_folder4"], 
            "sourcetype":'ccw_source', "file":'ccw_file'}
        ]
        
#
need_restart = False
kdl =  keysdownloader.keysdownloader()
for onepars in pars:
    tmpstr = ""
    kdl.tasks[onepars["name"]]["enable"] = addon.getSetting(onepars["enable"]) == "true"
    if kdl.tasks[onepars["name"]]["enable"]:
        tmpstr = addon.getSetting(onepars["sourcetype"])
        kdl.tasks[onepars["name"]]["sourcetype"] = int(tmpstr)
        tmpstr = addon.getSetting(onepars["file"])
        kdl.tasks[onepars["name"]]["file"] = tmpstr
        tmpstr = addon.getSetting(onepars["realname"])
        if tmpstr: kdl.tasks[onepars["name"]]["realname"] = tmpstr
        tmpstr = addon.getSetting(onepars["url"])
        if tmpstr:
            kdl.tasks[onepars["name"]]["url"] = tmpstr
            if kdl.tasks[onepars["name"]]["istext"]:
                kdl.tasks[onepars["name"]]["delcomment"] = False
        for onepath in onepars["path"]:
            tmpstr = addon.getSetting(onepath)
            if tmpstr: kdl.tasks[onepars["name"]]["path"].append(tmpstr)
        if len( kdl.tasks[onepars["name"]]["path"] ) < 1:
            kdl.tasks[onepars["name"]]["enable"] = False
kdl.enableXBMCprogress = True
kdl.run_process()
for onetask in kdl.tasks.values():
    need_restart = need_restart or onetask["result"]
"""    
str1 = addon.getSetting("anything")
dialog.ok(u"",u'Set run \n sck_download = %s \n Anything = %s'%(addon.getSetting("sck_download"),  str1))
if not str1: addon.setSetting("anything",  "anything")
"""
